/**
 * 文件的存储，推荐使用七牛、阿里云、华为云、腾讯云等文件服务
 *
 * 在不采用云服务的情况下，我们有几种技术选型：
 * 方案 1. 使用自建的文件服务，例如说 minIO、FastDFS 等等
 * 方案 2. 使用服务器的文件系统存储
 * 方案 3. 使用数据库进行存储
 *
 * 如果考虑额外在搭建服务，推荐方案 1。
 * 对于方案 2 来说，如果要实现文件存储的高可用，需要多台服务器之间做实时同步，可以基于 rsync + inotify 来做
 * 对于方案 3 的话，实现起来最简单，但是数据库本身不适合存储海量的文件
 *
 * 综合考虑，暂时使用方案 3 的方式，比较适合这样一个 all in one 的项目。
 * 随着文件的量级大了之后，还是推荐采用云服务。
 */
package cn.iocoder.yudao.coreservice.modules.infra.framework.file;
